//
//  main.m
//  Playground
//
//  Created by Michael Ward on 4/23/12.
//  Copyright (c) 2012 Big Nerd Ranch, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "WKESomeClass.h"

int main(int argc, const char * argv[])
{
    @autoreleasepool {
        
        // Asking the factory to create an NSDate instance initialized to today's date.
        NSDate *aDate = [NSDate date];  
        NSDate *bDate = [[NSDate alloc] init];
        __unused NSDate *cDate = [bDate dateByAddingTimeInterval:60];
        
        
        // Message with one argument
        __unused NSDate *anotherDate = [NSDate dateWithTimeIntervalSinceNow:10000];
        
        // Two arguments
        NSDate *yetAnotherDate = [NSDate dateWithTimeInterval:5000 sinceDate:aDate];
        
        // anonymously-typed pointer to yetAnotherDate
        __unused id dateWithStupidType = yetAnotherDate;
        
        // An intro to the NSLog() function
        NSString *myString = nil;
        NSLog(@" %@ ",myString);// logs myString to the console
        NSLog(@"Hello, world!");// logs "Hello, world!" to the console.   
        
        // NSString
        NSString *helloString = @"Hello,";
        NSString *anotherString = [helloString stringByAppendingString:@" World!"];
        NSLog(@"The string is: %@",anotherString);
        NSLog(@"The date is: %@",anotherDate); // anotherDate is sent the -description msg
        
        // NSArray
        __unused NSArray *stringArray = [NSArray arrayWithObjects:helloString,@"Blah",nil];
        __unused NSArray *singleObjectArray = [NSArray arrayWithObject:helloString];
        NSArray *dateArray = [NSArray arrayWithObjects:aDate, bDate, cDate, nil];
        
        // Fast enumeration for arrays, dictionaries, sets
        for (NSDate *thisDate in dateArray) {
            NSDate *innerDate = [thisDate dateByAddingTimeInterval:10];
            NSLog(@"innerDate: %@",innerDate);
        }
        
        // isEqual: checks for content (vs. pointer comparison / ==)
        BOOL theyAreEqual = [stringArray isEqual:singleObjectArray]; // false
        BOOL itIsInThere = [stringArray containsObject:@"Blah"]; // true
        BOOL versionTwo = ([stringArray indexOfObjectIdenticalTo:@"Blah"] == NSNotFound);
        // Actually, that last one will return true (trick question)
        // due to the way the compiler and runtime optimize string literals
        
        WKESomeClass *someInstance = [[WKESomeClass alloc] init];
        
        // Dot Notation
        int i;
        i = someInstance.someInt;
        i = [someInstance someInt]; // these two lines are _identical_
        
        someInstance.someInt = 5;
        [someInstance setSomeInt:5]; // as are these
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
    }
    return 0;
}

